#include <iostream>
using namespace std;

/**
  Dernier jour d'un mois
  @param[in] mm - numéro de mois
  @return le dernier jour de mm
*/

int dernierJour0(int mm)
{
  int rs = 0;
  switch (mm)
  {
    case 1: case 3: case 5: case 7: case 8: case 10: case 12:
      rs = 31;
      break;
    case 4: case 6: case 9: case 11:
      rs = 30;
      break;
    case 2:
      rs = 28;
      break;
  }
  return rs;
}

/**
  @test
*/

void test_sjours0()
{
  int mois;
  cout<<"De quel mois s'agit-il? ";
  cin>>mois;
  int njours = dernierJour0(mois);
  if (njours != 0)
  {
    cout<<"==> Dernier jour du mois "<<mois<<" est "<<njours<<endl;
  }
  else
  {
    cout<<"==> Impossible ce mois n'existe pas"<<endl;
  }
}

/**
  Prédicat de divisibilité
  @param[in] n - un entier
  @param[in] d - un entier
  @return Vrai si n est divisible par d, Faux sinon
*/

bool divisible(int n, int d)
{
  return (n % d == 0);
}

/**
  Prédicat bissextile
  @param[in] an - une annee
  @return Vrai si an est une année bissextile, Faux sinon
*/

bool bissextile(int an)
{
  return (divisible(an,4) && !divisible(an,100)) || divisible(an,400);
}

/**
  @test
*/

void test_bissextile()
{
  int annee;
  cout<<"Annee? ";
  cin>>annee;
  cout<<"==> "<<bissextile(annee)<<endl;
}

/**
  Dernier jour d'un (mois,annee)
  @param[in] mm - numéro de mois
  @param[in] an - millésime d'une annee
  @return le dernier jour de (mm,an)
*/

int dernierJour(int mm, int an)
{
  int rs = 0;
  switch (mm)
  {
    case 1: case 3: case 5: case 7: case 8: case 10: case 12:
      rs = 31;
      break;
    case 4: case 6: case 9: case 11:
      rs = 30;
      break;
    case 2:
      rs = (bissextile(an) ? 29 : 28);
      break;
  }
  return rs;
}

/**
  @test
*/

void test_sjours()
{
  int mois;
  cout<<"De quel mois s'agit-il? ";
  cin>>mois;
  int annee;
  cout<<"De quelle annee? ";
  cin>>annee;
  int njours = dernierJour(mois,annee);
  if (njours != 0)
  {
    cout<<"==> En "<<annee<<" le dernier jour du mois "<<mois<<" est "<<njours<<endl;
  }
  else
  {
    cout<<"==> Impossible ce mois n'existe pas"<<endl;
  }
}

/**
  Prédicat de date valide
  @param[in] jr - numéro de jour
  @param[in] mm - numéro de mois
  @param[in] an - millésime d'une année
  @return Vrai si (jr,mm,an) est valide, Faux sinon
*/

bool datum(int jr, int mm, int an)
{
  return (an >= 0) && ((1 <= mm) && (mm <= 12)) && ((1 <= jr) && (jr <= dernierJour(mm,an)));
}

/**
  @test
*/

void test_saisir()
{
  int jj = 0, mm = 0, aa = 0;
  while (!datum(jj,mm,aa))
  {
    cout<<"Date jj mm aa? ";
    cin>>jj>>mm>>aa;
  }
}

int main()
{
  test_sjours0();
  test_bissextile();
  test_sjours();
  test_saisir();
}
