import java.util.Scanner;

class PGSjours {

/**
  Dernier jour d'un mois
  @param[in] mm - numéro de mois
  @return le dernier jour de mm
*/

public static int dernierJour0(int mm)
{
  int rs = 0;
  switch (mm)
  {
    case 1: case 3: case 5: case 7: case 8: case 10: case 12:
      rs = 31;
      break;
    case 4: case 6: case 9: case 11:
      rs = 30;
      break;
    case 2:
      rs = 28;
      break;
  }
  return rs;
}

/**
  @test
*/

public static void test_sjours0()
{
  Scanner input = new Scanner(System.in);
  int mois;
  System.out.print("De quel mois s'agit-il? ");
  mois = input.nextInt();
  int njours = dernierJour0(mois);
  if (njours != 0)
  {
    System.out.println("==> Dernier jour du mois " + mois + " est " + njours);
  }
  else
  {
    System.out.println("==> Impossible ce mois n'existe pas");
  }
}

/**
  Prédicat de divisibilité
  @param[in] n - un entier
  @param[in] d - un entier
  @return Vrai si n est divisible par d, Faux sinon
*/

public static boolean divisible(int n, int d)
{
  return (n % d == 0);
}

/**
  Prédicat bissextile
  @param[in] an - une annee
  @return Vrai si an est une année bissextile, Faux sinon
*/

public static boolean bissextile(int an)
{
  return (divisible(an,4) && !divisible(an,100)) || divisible(an,400);
}

/**
  @test
*/

public static void test_bissextile()
{
  Scanner input = new Scanner(System.in);
  int annee;
  System.out.print("Annee? ");
  annee = input.nextInt();
  System.out.println("==> " + bissextile(annee));
}

/**
  Dernier jour d'un (mois,annee)
  @param[in] mm - numéro de mois
  @param[in] an - millésime d'une annee
  @return le dernier jour de (mm,an)
*/

public static int dernierJour(int mm, int an)
{
  int rs = 0;
  switch (mm)
  {
    case 1: case 3: case 5: case 7: case 8: case 10: case 12:
      rs = 31;
      break;
    case 4: case 6: case 9: case 11:
      rs = 30;
      break;
    case 2:
      rs = (bissextile(an) ? 29 : 28);
      break;
  }
  return rs;
}

/**
  @test
*/

public static void test_sjours()
{
  Scanner input = new Scanner(System.in);
  int mois;
  System.out.print("De quel mois s'agit-il? ");
  mois = input.nextInt();
  int annee;
  System.out.print("De quelle annee? ");
  annee = input.nextInt();
  int njours = dernierJour(mois,annee);
  if (njours != 0)
  {
    System.out.println("==> En " + annee + " le dernier jour du mois " + mois + " est " + njours);
  }
  else
  {
    System.out.println("==> Impossible ce mois n'existe pas");
  }
}

/**
  Prédicat de date valide
  @param[in] jr - numéro de jour
  @param[in] mm - numéro de mois
  @param[in] an - millésime d'une année
  @return Vrai si (jr,mm,an) est valide, Faux sinon
*/

public static boolean datum(int jr, int mm, int an)
{
  return (an >= 0) && ((1 <= mm) && (mm <= 12)) && ((1 <= jr) && (jr <= dernierJour(mm,an)));
}

/**
  @test
*/

public static void test_saisir()
{
  Scanner input = new Scanner(System.in);
  int jj = 0, mm = 0, aa = 0;
  while (!datum(jj,mm,aa))
  {
    System.out.print("Date jj mm aa? ");
    jj = input.nextInt();
    mm = input.nextInt();
    aa = input.nextInt();
  }
}

public static void main(String[] args)
{
  test_sjours0();
  test_bissextile();
  test_sjours();
  test_saisir();
}

}
