
def dernierJour0(mm):
    """  Dernier jour d'un mois
 
     :param mm: numéro de mois
     :return: le dernier jour de mm
    """
    rs = 0
    if mm == 1 or mm == 3 or mm == 5 or mm == 7 or mm == 8 or mm == 10 or mm == 12:
        rs = 31
    elif mm == 4 or mm == 6 or mm == 9 or mm == 11:
        rs = 30
    elif mm == 2:
        rs = 28
    return rs


def test_sjours0():
    """ @test """
    mois = int(input("De quel mois s'agit-il? "))
    njours = dernierJour0(mois)
    if njours != 0:
        print("==> Dernier jour du mois ", mois, " est ", njours, sep="")
    else:
        print("==> Impossible ce mois n'existe pas")


def divisible(n, d):
    """  Prédicat de divisibilité
 
     :param n: un entier
     :param d: un entier
     :return: Vrai si n est divisible par d, Faux sinon
    """
    return (n % d == 0)


def bissextile(an):
    """  Prédicat bissextile
 
     :param an: une annee
     :return: Vrai si an est une année bissextile, Faux sinon
    """
    return (divisible(an, 4) and not divisible(an, 100)) or divisible(an, 400)


def test_bissextile():
    """ @test """
    annee = int(input("Annee? "))
    print("==> ", bissextile(annee), sep="")


def dernierJour(mm, an):
    """  Dernier jour d'un (mois,annee)
 
     :param mm: numéro de mois
     :param an: millésime d'une annee
     :return: le dernier jour de (mm,an)
    """
    rs = 0
    if mm == 1 or mm == 3 or mm == 5 or mm == 7 or mm == 8 or mm == 10 or mm == 12:
        rs = 31
    elif mm == 4 or mm == 6 or mm == 9 or mm == 11:
        rs = 30
    elif mm == 2:
        rs = (29 if bissextile(an) else 28)
    return rs


def test_sjours():
    """ @test """
    mois = int(input("De quel mois s'agit-il? "))
    annee = int(input("De quelle annee? "))
    njours = dernierJour(mois, annee)
    if njours != 0:
        print("==> En ", annee, " le dernier jour du mois ", mois, " est ", njours, sep="")
    else:
        print("==> Impossible ce mois n'existe pas")


def datum(jr, mm, an):
    """  Prédicat de date valide
 
     :param jr: numéro de jour
     :param mm: numéro de mois
     :param an: millésime d'une année
     :return: Vrai si (jr,mm,an) est valide, Faux sinon
    """
    return (an >= 0) and ((1 <= mm) and (mm <= 12)) and ((1 <= jr) and (jr <= dernierJour(mm, an)))


def test_saisir():
    """ @test """
    jj, mm, aa = 0, 0, 0
    while not datum(jj, mm, aa):
        print("Date jj mm aa? ", sep="", end="")
        jj = int(input())
        mm = int(input())
        aa = int(input())


def PGSjours():
    test_sjours0()
    test_bissextile()
    test_sjours()
    test_saisir()

PGSjours()